#include <stdio.h>

#define BOARDSIZE 50
#define PIXPATH PixPath
#define PIXEXT  PixExt

char board[BOARDSIZE][BOARDSIZE];
int markup[BOARDSIZE][BOARDSIZE];
char PixPath [10] = "PGM";
char PixExt  [10] = "pgm";

void PrintMaze() {
	int row,col;

	for (row = 0; row < 20; row++) {
		for (col = 0; col < 20; col++) {
			printf("%c",board[row][col]);
		}
	}
	printf("\n");
}

void SetInside(int depth, int row, int col) {
	
	if (markup[row][col] == 1 || row<0 || row >= BOARDSIZE || col<0 || col >= BOARDSIZE) return;
	markup[row][col] = 1;
	if (board[row][col] != ' ' && board[row][col] != '#') {
		if (board[row][col] == '~') board[row][col] = ' ';
		SetInside(depth+1,row+1,col);
		SetInside(depth+1,row-1,col);
		SetInside(depth+1,row,col+1);
		SetInside(depth+1,row,col-1);
	}
}

int main(int argc, char **argv)
{
	char sq,ch[2000],fname[5];
	int  row,col,i,on;
	int  maxcol;
	int  Numbers,Color,Border;
	int  manrow,mancol;

	Numbers = Color = Border = 1;
	for (i=1; i<argc; i++) {
/* fprintf(stderr,"next arg: %s\n", argv[i]); */
		if (argv[i][0] == '-') on = 0;
		else on = 1;
		switch (argv[i][1]) {
		 case 'c': /* color */
			Color = on;
			if (Color) {
			    strcpy(PixPath,"PPM");
			    strcpy(PixExt,"ppm");
			}
			break;
		 case 'n': /* letters and numbers */
			Numbers = on;
			break;
		 case 'b': /* boarder */
			Border = on;
			break;
		 default: fprintf(stderr, "Usage: ascii2tcsh [+-]n[umber] [+-]c[olor] [+-]b[oarder] < asciifile >tcshfile\n");
			     exit(1);
		}
	}

	
	row = col = maxcol = 0;
	while ( (sq = getc(stdin)) != EOF) {
		board[row][col] = sq;
		switch (sq) {
		 case '\n': 
			if (col>maxcol) maxcol=col;
			col = 0; 
			row++; 
			break;
		 case '+':
		 case '@':
			manrow = row;
			mancol = col;
			col++;
			break;
		 case ' ': 
			board[row][col] = '~';
			col++;
			break;
		 default: col++;
		}
	}
	board[row][col] = EOF;

	memset(markup,0,sizeof(int)*BOARDSIZE*BOARDSIZE);
	SetInside(0,manrow,mancol);

	/* create letters on top */
	if (Border) {
	    printf("pnmcat -lr %s/outside.%s",PIXPATH,PIXEXT);
	    for (col=0; col<maxcol; col++)
		printf(" %s/%c.%s", PIXPATH, 'A'+col, PIXEXT);
	}

	for (row=0; row<BOARDSIZE; row++) {
		if (row || Border) printf("> %02d.row\n",row);
		if (board[row][0]!='\n') {
			if (Border) 
			    printf("pnmcat -lr %s/%c.%s",
				    PIXPATH, 'a'+row, PIXEXT);
			else
			    printf("pnmcat -lr ");
		} else {
			break;
		}
		for (col=0; col<maxcol; col++) {
			switch (board[row][col]) {
			 case '\n': 
				for (; col<maxcol; col++) {
					printf(" %s/outside.%s",PIXPATH,PIXEXT);
				}
				break;

			 case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
			 case 'G': case 'H': case 'I': case 'J': case 'K': case 'L': 
			 case 'M': case 'N': case 'O': case 'P': case 'Q': case 'R': 
			 case 'S': case 'T': 
				if (Numbers == 1) {
				   printf(" %s/%c.%s",PIXPATH,board[row][col]-'A'+10,PIXEXT);
				   break;
				}
			 case '$': 
				printf(" %s/stone.%s",PIXPATH,PIXEXT);
				break;
			 case ' ':  
				printf(" %s/empty.%s",PIXPATH,PIXEXT);
				break;
			 case '@':  
				printf(" %s/man.%s",PIXPATH,PIXEXT);
				break;
			 case '%':
			 case '+':  
				printf(" %s/saveman.%s",PIXPATH,PIXEXT);
				break;
			 case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
			 case 'g': case 'h': case 'i': case 'j': case 'k': case 'l': 
			 case 'm': case 'n': case 'o': case 'p': case 'q': case 'r': 
			 case 's': case 't': 
			 case '.':  
				printf(" %s/save.%s",PIXPATH,PIXEXT);
				break;
			 case '~':  
				printf(" %s/outside.%s",PIXPATH,PIXEXT);
				break;
			 case '*':  
				printf(" %s/savestone.%s",PIXPATH,PIXEXT);
				break;
			 case '#':   if (row>0 && board[row-1][col]=='#') fname[0] = 'N';
				else fname[0] = 'n';
			 	if (col<BOARDSIZE && board[row][col+1]=='#') fname[1] = 'E';
				else fname[1] = 'e';
			 	if (row<BOARDSIZE && board[row+1][col]=='#') fname[2] = 'S';
				else fname[2] = 's';
			 	if (col>0 && board[row][col-1]=='#') fname[3] = 'W';
				else fname[3] = 'w';
				fname[4] = '\0';
				printf(" %s/w%s.%s",PIXPATH,fname,PIXEXT);
				break;
			 case '1': case '2': case '3': case '4': case '5': 
			 case '6': case '7': case '8': case '9': case '0':
			 case 'U': case 'V': case 'W': case 'X': case 'Y': case 'Z':
			 case 'u': case 'v': case 'w': case 'x': case 'y': case 'z':
			 default: printf("PANIC: error in input file!!!");
				printf("Pos row: %i  col: %i  char: '%c'\n",
					row, col, board[row][col]);
				exit(1);
			}
		}
	}
	printf("pnmcat -tb ??.row >maze.%s\n",PIXEXT);
	printf("rm -f ??.row\n",PIXEXT);
	exit(0);
}
